Index: sys/ufs/ffs/ffs_alloc.c
===================================================================
RCS file: /cvsroot/src/sys/ufs/ffs/ffs_alloc.c,v
retrieving revision 1.113.4.1
diff -u -r1.113.4.1 ffs_alloc.c
--- sys/ufs/ffs/ffs_alloc.c	24 Feb 2009 04:13:35 -0000	1.113.4.1
+++ sys/ufs/ffs/ffs_alloc.c	24 Apr 2009 11:50:25 -0000
@@ -1369,7 +1369,7 @@
 	ufs_add32(cgp->cg_frsum[allocsiz], -1, needswap);
 	if (frags != allocsiz)
 		ufs_add32(cgp->cg_frsum[allocsiz - frags], 1, needswap);
-	blkno = cg * fs->fs_fpg + bno;
+	blkno = cgbase(fs, cg) + bno;
 	ACTIVECG_CLR(fs, cg);
 	mutex_exit(&ump->um_lock);
 	if (DOINGSOFTDEP(ITOV(ip)))
@@ -1573,7 +1573,7 @@
 		    got - run + i))
 			panic("ffs_clusteralloc: map mismatch");
 #endif
-	bno = cg * fs->fs_fpg + blkstofrags(fs, got - run + 1);
+	bno = cgbase(fs, cg) + blkstofrags(fs, got - run + 1);
 	if (dtog(fs, bno) != cg)
 		panic("ffs_clusteralloc: allocated out of group");
 	len = blkstofrags(fs, len);
